#include <avm/cec.h>
#include <avm/config.h>
#include <avm/drc.h>
#include <avm/tv.h>
#include <camera/camera.h>
#include <coreinit/alarm.h>
#include <coreinit/atomic.h>
#include <coreinit/atomic64.h>
#include <coreinit/bsp.h>
#include <coreinit/cache.h>
#include <coreinit/codegen.h>
#include <coreinit/condition.h>
#include <coreinit/context.h>
#include <coreinit/copydata.h>
#include <coreinit/core.h>
#include <coreinit/coroutine.h>
#include <coreinit/cosreport.h>
#include <coreinit/debug.h>
#include <coreinit/dynload.h>
#include <coreinit/energysaver.h>
#include <coreinit/event.h>
#include <coreinit/exception.h>
#include <coreinit/exit.h>
#include <coreinit/fastcondition.h>
#include <coreinit/fastmutex.h>
#include <coreinit/fiber.h>
#include <coreinit/filesystem.h>
#include <coreinit/filesystem_fsa.h>
#include <coreinit/foreground.h>
#include <coreinit/ipcbufpool.h>
#include <coreinit/im.h>
#include <coreinit/internal.h>
#include <coreinit/interrupts.h>
#include <coreinit/ios.h>
#include <coreinit/kernel.h>
#include <coreinit/mcp.h>
#include <coreinit/memallocator.h>
#include <coreinit/memblockheap.h>
#include <coreinit/memdefaultheap.h>
#include <coreinit/memexpheap.h>
#include <coreinit/memfrmheap.h>
#include <coreinit/memheap.h>
#include <coreinit/memlist.h>
#include <coreinit/memory.h>
#include <coreinit/memorymap.h>
#include <coreinit/memunitheap.h>
#include <coreinit/messagequeue.h>
#include <coreinit/mutex.h>
#include <coreinit/performancemonitor.h>
#include <coreinit/rendezvous.h>
#include <coreinit/savedframe.h>
#include <coreinit/scheduler.h>
#include <coreinit/screen.h>
#include <coreinit/semaphore.h>
#include <coreinit/smd.h>
#include <coreinit/spinlock.h>
#include <coreinit/stopwatch.h>
#include <coreinit/stopwatchatomic.h>
#include <coreinit/systeminfo.h>
#include <coreinit/taskqueue.h>
#include <coreinit/thread.h>
#include <coreinit/threadqueue.h>
#include <coreinit/time.h>
#include <coreinit/title.h>
#include <coreinit/transition.h>
#include <coreinit/userconfig.h>
#include <dmae/mem.h>
#include <dmae/sync.h>
#include <gx2/aperture.h>
#include <gx2/clear.h>
#include <gx2/context.h>
#include <gx2/debug.h>
#include <gx2/display.h>
#include <gx2/displaylist.h>
#include <gx2/draw.h>
#include <gx2/enum.h>
#include <gx2/event.h>
#include <gx2/mem.h>
#include <gx2/registers.h>
#include <gx2/sampler.h>
#include <gx2/shaders.h>
#include <gx2/state.h>
#include <gx2/surface.h>
#include <gx2/swap.h>
#include <gx2/temp.h>
#include <gx2/tessellation.h>
#include <gx2/texture.h>
#include <gx2/utils.h>
#include <gx2r/buffer.h>
#include <gx2r/displaylist.h>
#include <gx2r/draw.h>
#include <gx2r/mem.h>
#include <gx2r/resource.h>
#include <gx2r/surface.h>
#include <h264/stream.h>
#include <h264/decode.h>
#include <mic/mic.h>
#include <nfc/nfc.h>
#include <nn/ac/ac_c.h>
#include <nn/ac/ac_cpp.h>
#include <nn/acp/client.h>
#include <nn/acp/drcled_c.h>
#include <nn/acp/drcled_cpp.h>
#include <nn/acp/device.h>
#include <nn/acp/nn_acp_types.h>
#include <nn/acp/result.h>
#include <nn/acp/save.h>
#include <nn/acp/title.h>
#include <nn/act/client_cpp.h>
#include <nn/ccr/sys.h>
#include <nn/ccr/sys_caffeine.h>
#include <nn/cmpt/cmpt.h>
#include <nn/ffl/miidata.h>
#include <nn/hpad/beta.h>
#include <nn/hpad/hpad.h>
#include <nn/nets2/somemopt.h>
#include <nn/nfp/nfp_cpp.h>
#include <nn/nfp/amiibo_settings_cpp.h>
#include <nn/pdm/pdm_c.h>
#include <nn/pdm/pdm_cpp.h>
#include <nn/swkbd/swkbd_cpp.h>
#include <nn/spm/storage.h>
#include <nn/temp/temp.h>
#include <nn/ac.h>
#include <nn/acp.h>
#include <nn/act.h>
#include <nn/ccr.h>
#include <nn/cfg/CTR.h>
#include <nn/cmpt.h>
#include <nn/dlp.h>
#include <nn/hpad.h>
#include <nn/result.h>
#include <nn/sl.h>
#include <nn/nets2.h>
#include <nn/nfp.h>
#include <nn/pdm.h>
#include <nn/swkbd.h>
#include <nn/spm.h>
#include <nn/save.h>
#include <nn/temp.h>
#include <nn/uds.h>
#include <ntag/ntag.h>
#include <nsysccr/ccr.h>
#include <nsysccr/cdc.h>
#include <nsysccr/cfg.h>
#include <nsysccr/hid.h>
#include <nsysccr/nfc.h>
#include <nsysccr/irda.h>
#include <nsyshid/hid.h>
#include <nsysnet/_socket.h>
#include <nsysnet/misc.h>
#include <nsysnet/netconfig.h>
#include <nsysnet/nssl.h>
#include <nsysuhs/uhs.h>
#include <nsyskbd/nsyskbd.h>
#include <padscore/kpad.h>
#include <padscore/wpad.h>
#include <padscore/wbc.h>
#include <proc_ui/procui.h>
#include <proc_ui/memory.h>
#include <sndcore2/core.h>
#include <sndcore2/device.h>
#include <sndcore2/drcvs.h>
#include <sndcore2/result.h>
#include <sndcore2/voice.h>
#include <swkbd/rpl_interface.h>
#include <sysapp/args.h>
#include <sysapp/launch.h>
#include <sysapp/switch.h>
#include <sysapp/title.h>
#include <tve/cec.h>
#include <tve/tve.h>
#include <vpad/input.h>
#include <vpadbase/base.h>
#include <wut.h>
#include <wut_structsize.h>
#include <wut_types.h>
